/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.CortesiaDAO;
import com.rjconsultores.ventaboletos.entidad.Cortesia;
import com.rjconsultores.ventaboletos.entidad.Empleado;

/**
 *
 * @author Shiro
 */
@Repository("cortesiaDAO")
public class CortesiaHibernateDAO extends GenericHibernateDAO<Cortesia, Integer>
        implements CortesiaDAO {

    @Autowired
    public CortesiaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<Cortesia> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

    public List<Cortesia> pesquisar(Empleado empleado) {

        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));


        if (empleado != null) {
            c.add(Restrictions.eq("empleado", empleado));
        }
        return c.list();
    }

    public Cortesia buscar(Cortesia cortesia) {

        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));


        if (cortesia != null) {
            c.add(Restrictions.eq("empleado", cortesia));
        }
        return (Cortesia) c.uniqueResult();
    }

    public List<Cortesia> buscarDplicidad(Cortesia cortesia) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        c.add(Restrictions.eq("empleado", cortesia.getEmpleado()));
        c.add(Restrictions.eq("marca", cortesia.getMarca()));
        c.add(Restrictions.eq("claseServicio", cortesia.getClaseServicio()));
        c.add(Restrictions.eq("origem", cortesia.getOrigem()));
        c.add(Restrictions.eq("destino", cortesia.getDestino()));
        c.add(Restrictions.eq("fecinicio", cortesia.getFecinicio()));
        c.add(Restrictions.eq("fecfinal", cortesia.getFecfinal()));

        return c.list();
    }
}
